package com.hello2morrow.sonargraph.languageprovider.java.command.system.scripts;

import static org.junit.Assert.*

import com.hello2morrow.sonargraph.core.model.common.Severity
import com.hello2morrow.sonargraph.core.model.script.GroovyScript
import com.hello2morrow.sonargraph.core.model.script.ScriptIssueElementTreeNode
import com.hello2morrow.sonargraph.core.model.script.ScriptNamedTreeNode
import com.hello2morrow.sonargraph.core.model.script.ScriptResultSet
import com.hello2morrow.sonargraph.core.model.script.ScriptSeverityTreeNode
import com.hello2morrow.sonargraph.languageprovider.java.foundation.common.JavaTestFixture
import com.hello2morrow.sonargraph.languageprovider.java.model.programming.JavaMethod

public class FeatureEnvyScriptTest extends AbstractJavaScriptTest
{
    private static final String PROJECT_PATH = JavaTestFixture.SCRIPT_FEATURE_ENVY_PROJECT_PATH;
    private static final String SCRIPT_PATH = JavaTestFixture.SCRIPT_FEATURE_ENVY_SCRIPT_PATH;

    public FeatureEnvyScriptTest()
    {
        super(PROJECT_PATH, SCRIPT_PATH);
    }

    @Override
    void verifyResult(GroovyScript script)
    {
        ScriptResultSet result = script.getResultSet();
        ScriptNamedTreeNode issues = result.getIssueRootNode();

        List<ScriptSeverityTreeNode> scriptWarnings = issues.getChildren().findAll
        {
            if (it instanceof ScriptSeverityTreeNode)
            {
                ScriptSeverityTreeNode node = (ScriptSeverityTreeNode) it;
                if (node.getSeverity() == Severity.WARNING)
                {
                    return node;
                }
                return null;
            }
        }
        assertEquals(1, scriptWarnings.size());

        ScriptSeverityTreeNode severityNode = scriptWarnings.get(0);
        List<ScriptIssueElementTreeNode> warningNodes = severityNode.getChildren().get(0).getChildren().findAll
        { it instanceof ScriptIssueElementTreeNode }

        assertEquals(1, warningNodes.size());

        ScriptIssueElementTreeNode node1 = warningNodes.find
        {
            if (! (it.getElement() instanceof JavaMethod))
            {
                return false;
            }

            JavaMethod method = (JavaMethod) it.getElement();
            println "method: " + method.getName()
            println "class: " + method.getParent().getName()
            if (!method.getName().equals("com.hello2morrow.sonargraph.scripttest.Using.test()") || !method.getParent().getName().equals("com.hello2morrow.sonargraph.scripttest.Using"))
            {
                return false;
            }
            return true;
        }

        assertNotNull("Expected method 'test()' not found", node1);
    }
}
